︠39d9b08e-c568-4c6a-9d51-41dc9eb59b77s︠
reset()
typeset_mode(True)
︡95a9e73a-5a69-4cc4-93bc-da86e8b65825︡︡{"done":true}
︠a294aa10-d3a3-4679-be01-0ade49109b10s︠
def all_paths(G,a,b):
    old_paths = G.all_paths( a, b ) # get all paths without edge multiplicity
    new_paths=[]
    for p in old_paths: # traverse each path replacing each edge by a list of (multi) edges
        multi_path=[]
        for i,u in enumerate(p):
            if i < len(p)-1:
                v = p[i+1]
                edges = G.edge_boundary([u], [v] )
                multi_path.append(edges)
        new_paths.extend( CartesianProduct(*multi_path )) # each sequence of (multi) edges will be a source of multiple paths
        #new_paths.extend( cartesian_product(*multi_path ))
    return new_paths
︡eacc0d68-72b6-44ee-9145-5a313db7f6ff︡︡{"done":true}
︠b9b0a255-c948-44c7-ba40-a10a0a4ae5f2s︠
# start is at position 1 and end is position 5
_ = var('start')
_ = var('end')
︡06526fc4-41aa-4dd6-bf7c-9e3bc9746f74︡︡{"done":true}
︠d0b3f6b9-c447-42b5-bc5b-b5615cdea90cs︠
# define all the positions
for i in ['A','B']:
    for j in [1..2]:
        for k in ['a','b']:
            for l in [1..8]:
                _ = var(str(i)+str(j)+str(k)+'Pos'+str(l))
︡d42d1ffa-eb4a-4955-99e3-b8caf39f62dc︡︡{"done":true}
︠40d26f7a-2065-4542-83ec-cabc59378562s︠
#Add arrows for calls, small subset, rest are at end

reset('D')
# create the graph
D = DiGraph(multiedges=True)

for i in ['BRPT']:
    D.add_edge(start,A1aPos4,str(i))
    D.add_edge(B2aPos6,end,str(i))
    for j in [[1,4],[2,1],[3,2],[4,3],[5,8],[6,5],[7,6],[8,7]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['CL4','MAL1','MAR1','WAL1','WAR1','LL','MG1','WG1','MDsD1','WDsD1','NDsD1','NAL1','NAR1']:
    D.add_edge((start,A1aPos1,str(i)))
    D.add_edge((B2aPos5,end,str(i)))
    for j in [[1,1],[2,2],[3,3],[4,4],[5,5],[6,6],[7,7],[8,8]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['WHH','MHH']:
    D.add_edge((start,A1aPos7,str(i)))
    D.add_edge((B2aPos3,end,str(i)))
    D.add_edge((B2aPos7,end,str(i)))
    for j in [[1,7],[2,4],[3,5],[4,2],[5,7],[6,2],[7,5],[8,4]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['WAL1.5','WAR1.5']:
    D.add_edge((start,A1aPos8,str(i)))
    D.add_edge((B2aPos2,end,str(i)))
    for j in [[1,8],[2,5],[3,6],[4,7],[5,2],[6,3],[7,4],[8,1]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['MAL1.5','MAR1.5','MG1.5','MDsD1.5']:
    D.add_edge((start,A1aPos6,str(i)))
    D.add_edge((B2aPos4,end,str(i)))
    for j in [[1,6],[2,7],[3,8],[4,5],[5,4],[6,1],[7,2],[8,3]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['RsLs']:
    D.add_edge((start,A1aPos6,str(i)))
    D.add_edge((B2aPos4,end,str(i)))
    for j in [[1,6],[2,7],[3,8],[4,5],[5,4],[6,1],[7,2],[8,3]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['BRCT']:
    D.add_edge((start,A1aPos7,str(i)))
    D.add_edge((B2aPos3,end,str(i)))
    for j in [[1,7],[2,6],[3,5],[4,8],[5,3],[6,2],[7,1],[8,4]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['WG1.5','WDsD1.5']:
    D.add_edge((start,A1aPos8,str(i)))
    D.add_edge((B2aPos4,end,str(i)))
    for j in [[1,8],[2,7],[3,6],[4,5],[5,4],[6,3],[7,2],[8,1]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['LC']:
    D.add_edge((start,A1aPos2,str(i)))
    D.add_edge((B2aPos2,end,str(i)))
    D.add_edge((B2aPos8,end,str(i)))
    for j in [[1,2],[2,5],[3,4],[4,7],[5,2],[6,7],[7,4],[8,5]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['PS']:
    for j in [[2,2],[4,4],[6,4],[8,2]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['NS']:
    D.add_edge((start,A1aPos5,str(i)))
    D.add_edge((B2aPos1,end,str(i)))
    D.add_edge((B2aPos5,end,str(i)))
    for j in [[1,5],[3,7],[5,5],[7,7]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['PDsD1','PAL1','PAR1']:
    for j in [[2,2],[4,4],[6,6],[8,8]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['PDsD1.5','PAL1.5','PAR1.5']:
    for j in [[2,8],[4,6],[6,4],[8,2]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['NDsD1','NALR1']:
    D.add_edge((start,A1aPos1,str(i)))
    D.add_edge((B2aPos5,end,str(i)))
    for j in [[1,1],[3,3],[5,5],[7,7]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['NDsD1.5','NAL1.5','NAR1.5']:
    D.add_edge((start,A1aPos5,str(i)))
    D.add_edge((B2aPos1,end,str(i)))
    for j in [[1,5],[3,7],[5,1],[7,3]]:
        for k in [['A1a','A1b'],['A1b','A2a'],['A2a','A2b'],['A2b','B1a'],['B1a','B1b'],['B1b','B2a']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))
︡9a790325-21c4-433e-af82-cc5d9a4917d9︡︡{"done":true}
︠1f7d484c-eafb-414b-8469-bb5ee870f7a6s︠
# show the graph, it's not pretty...yet
len(set(D.vertices()))
#D.graphplot(edge_labels=True,layout='circular').show()
D.graphplot(edge_labels=True,layout='circular').show()
D.get_pos()
#positions = D.get_pos()
#positions
#D.get_pos()
︡571b72f4-b9a4-46bd-8da5-19d2209d2c7f︡︡{"html":"<div align='center'>$\\displaystyle 58$</div>"}︡{"file":{"filename":"/projects/f5131d05-a281-4a3b-b456-e738f4182eb1/.sage/temp/compute6-us/1510/tmp_zuvjjl.svg","show":true,"text":null,"uuid":"dc112471-7643-471c-9a52-6a8a5a22b057"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠13896cee-2181-464b-931d-ef9c8c69ed02r︠
# count the dances
paths=all_paths(D,start,end)
len(paths)
︡a58f6664-e16a-4197-89d7-aedc85e28353︡
︠8f4261e4-d069-4233-83a0-4f30dc24bb6cw︠
D.set_pos({
        start:[0,4],
        A1aPos1:[1,7],
        A1aPos2:[1,6],
        A1aPos3:[1,5],
        A1aPos4:[1,4],
        A1aPos5:[1,3],
        A1aPos6:[1,2],
        A1aPos7:[1,1],
        A1aPos8:[1,0],
        A1bPos1:[2,7],
        A1bPos2:[2,6],
        A1bPos3:[2,5],
        A1bPos4:[2,4],
        A1bPos5:[2,3],
        A1bPos6:[2,2],
        A1bPos7:[2,1],
        A1bPos8:[2,0],
        A2aPos1:[3,7],
        A2aPos2:[3,6],
        A2aPos3:[3,5],
        A2aPos4:[3,4],
        A2aPos5:[3,3],
        A2aPos6:[3,2],
        A2aPos7:[3,1],
        A2aPos8:[3,0],
        A2bPos1:[4,7],
        A2bPos2:[4,6],
        A2bPos3:[4,5],
        A2bPos4:[4,4],
        A2bPos5:[4,3],
        A2bPos6:[4,2],
        A2bPos7:[4,1],
        A2bPos8:[4,0],
        B1aPos1:[5,7],
        B1aPos2:[5,6],
        B1aPos3:[5,5],
        B1aPos4:[5,4],
        B1aPos5:[5,3],
        B1aPos6:[5,2],
        B1aPos7:[5,1],
        B1aPos8:[5,0],
        B1bPos1:[6,7],
        B1bPos2:[6,6],
        B1bPos3:[6,5],
        B1bPos4:[6,4],
        B1bPos5:[6,3],
        B1bPos6:[6,2],
        B1bPos7:[6,1],
        B1bPos8:[6,0],
        B2aPos1:[7,7],
        B2aPos2:[7,6],
        B2aPos3:[7,5],
        B2aPos4:[7,4],
        B2aPos5:[7,3],
        B2aPos6:[7,2],
        B2aPos7:[7,1],
        B2aPos8:[7,0],
        end:[8,4]
    })

︡52c3129f-409a-4369-82d8-3cb2359c7424︡
︠41fc51fe-7692-4fd3-8702-dab49e6371b2w︠
D.graphplot(edge_labels=True).show(figsize=32)
︡f1a7e471-b802-4d24-8f6a-a05d737d542c︡
︠dce70ea6-3924-470c-acfd-482d52c515f8w︠
D.graphplot(edge_labels=True).show(figsize=128)
︡77a9f071-249f-47bc-b399-e126d4f11d26︡
︠e2e9e77b-26df-4662-81f4-ae603ae79c22w︠
D.get_pos()
︡3a548cde-020d-4f1e-b944-060a481e755a︡
︠93f70321-b0fd-4db0-9051-c8939522cc14w︠
D.set_pos()
D.plot(save_pos=True)
︡409f4f33-8ff7-4730-bc2c-06b1073ec687︡
︠19c4e147-9def-40e7-b2b4-f7b685e28800w︠
for p in paths:
    print p
︡a1632d40-15f8-4501-b632-d7a30a42f3c3︡
︠5ba276de-2427-472b-92df-83529ba46665w︠
D.show(edge_labels=True,layout='spring',iterations=20000)
︡511f3cfc-dbb6-41af-875e-ba68db6def46︡
︠15aa3921-285c-45be-a2e1-08d365ea3776w︠
D.show()
︡64563b46-623b-4f4f-aea4-846c98c1194b︡
︠484fe73a-221d-4598-aac2-418e4abfa2a0w︠
digraphs.Circuit(100).show()
digraphs.Circuit(100).show(iterations=20000)
︡b8f907b1-6920-4059-a152-c202df2f0f64︡
︠10067be7-52de-4af6-875b-b9eef17827a6︠
︡de929e31-fa87-42d4-ad1f-d3f09cc200ef︡
︠c6817e68-cc24-4b4e-9c3c-a896083a2c42w︠
︡381bedf9-40a6-481e-8406-9983cc2610c6︡
︠95669b4e-798b-4742-9153-29cb8d58270e︠
︡9d3acf5f-d87e-48ae-b427-06151711b7b6︡











